mount -o rw,remount /data
MODDIR=${0%/*}

# etc
if [ -d /sbin/.magisk ]; then
  MAGISKTMP=/sbin/.magisk
else
  MAGISKTMP=`find /dev -mindepth 2 -maxdepth 2 -type d -name .magisk`
fi
ETC=$MAGISKTMP/mirror/system/etc
VETC=$MAGISKTMP/mirror/vendor/etc
VOETC=$MAGISKTMP/mirror/vendor/odm/etc
MODETC=$MODDIR/system/etc
MODVETC=$MODDIR/system/vendor/etc
MODVOETC=$MODDIR/system/vendor/odm/etc

# conflicts
MOD=/data/adb/modules
AML=$MOD/aml
ACDB=$MOD/acdb
if [ -d $AML ] && [ -d $ACDB ]; then
  rm -rf $ACDB
fi
XML=`find $MOD -type f -name com.motorola.gamemode.xml`
APK=`find $MOD -type f -name MotoGametime.apk`
if echo $XML | grep -Eq xml && ! echo $APK | grep -Eq apk; then
  mv -f $XML $MOD
fi

# audio effects
FILE=*audio*effects*
rm -f `find $MODDIR/system -type f -name $FILE`
if [ ! -d $ACDB ] || [ -f $ACDB/disable ]; then
  AEC=`find $ETC -maxdepth 1 -type f -name $FILE.conf`
  VAEC=`find $VETC -maxdepth 1 -type f -name $FILE.conf`
  AEX=`find $ETC -maxdepth 1 -type f -name $FILE.xml`
  VAEX=`find $VETC -maxdepth 1 -type f -name $FILE.xml`
  cp -f $AEC $MODETC
  cp -f $VAEC $MODVETC
  cp -f $AEX $MODETC
  cp -f $VAEX $MODVETC
fi

# audio policy
FILE="*policy*.conf *policy*.xml"
rm -f `find $MODVETC -type f -name *policy*`
for FILES in $FILE; do
  AP=`find $VETC -maxdepth 1 -type f -name $FILES`
  AP2=`find $VETC/audio -maxdepth 1 -type f -name $FILES`
  AP3=`find $VOETC -maxdepth 1 -type f -name $FILES`
  cp -f $AP $MODVETC
  cp -f $AP2 $MODVETC/audio
  cp -f $AP3 $MODVOETC
done

# run
sh $MODDIR/.aml.sh

# directory
DIR=/data/waves
if [ ! -d $DIR ]; then
  mkdir -p $DIR
  chown 1013.1013 $DIR
fi

# cleaning
FILE=$MODDIR/cleaner.sh
if [ -f $FILE ]; then
  sh $FILE
  rm -f $FILE
fi





